<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CategoriaManutService;
use FM\Traits\TResponse;

class CategoriaManutController {
    use TResponse;
    protected $CategoriaManutService;

    public function __construct(CategoriaManutService $CategoriaManutService) {
        $this->CategoriaManutService = $CategoriaManutService;
    }

    public function saveCategoriaManutencao(Request $request) {
        try {
            $params = $request->getParameters();
            $this->CategoriaManutService->saveCategoriaManutencao($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCategoriasManutencao(Request $request) {
        try {
            $data = $this->CategoriaManutService->getCategoriasManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTecnicosRegistrados(Request $request) {
        try {
            $data = $this->CategoriaManutService->getTecnicosRegistrados();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteCategoriasManutencao(Request $request) {
        try {
            $params = $request->getParameters();
            $this->CategoriaManutService->deleteCategoriasManutencao($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>