<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class EscopoManutFactory {
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function insertEscopo($parametros) {

        $sql = "INSERT INTO FCM_ESCOPOMANUT (
                    NRESCOPOMANUT,  NMESCOPOMANUT,      NRORG,          IDATIVO,
                    DTINCLUSAO,     CDOPERINCLUSAO,     NRORGINCLUSAO,  DTULTATU,
                    CDOPERULTATU,   NRORGULTATU
                )
                VALUES (
                    :NRESCOPOMANUT, :NMESCOPOMANUT,     :NRORG,         'S',
                    SYSDATE,        :CDOPERINCLUSAO,    :NRORGINCLUSAO, SYSDATE,
                    :CDOPERULTATU,  :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function editEscopo($parametros) {
        $sql = "UPDATE FCM_ESCOPOMANUT
                SET NMESCOPOMANUT   = :NMESCOPOMANUT,
                    DTULTATU        = SYSDATE,
                    CDOPERULTATU    = :CDOPERULTATU,
                    NRORGULTATU     = :NRORGULTATU
                WHERE NRESCOPOMANUT = :NRESCOPOMANUT";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function getEscoposManutencao() {

        $sql = "SELECT NRESCOPOMANUT, NMESCOPOMANUT
                FROM FCM_ESCOPOMANUT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function deleteEscopos($parametro) {

        $sql = "DELETE 
                FROM FCM_ESCOPOMANUT
                WHERE NRESCOPOMANUT IN (".$parametro.")";

        $this->connection->executeStatement($sql);
    }
}

?>