<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class UnidadeMedidaFactory {
    use TQuery;
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function insertUnidadeMedida($parametros) {
        $sql = "INSERT INTO FCM_UNIDADEMEDIDA (
                    NRUNIDADEMEDIDA,    NMUNIDADEMEDIDA,    NMABREVUNIDADEMEDIDA,   NRORG,      IDATIVO,
                    DTINCLUSAO,         CDOPERINCLUSAO,     NRORGINCLUSAO,          DTULTATU,   CDOPERULTATU, 
                    NRORGULTATU
                )
                VALUES (
                    :NRUNIDADEMEDIDA,   :NMUNIDADEMEDIDA,   :NMABREVUNIDADEMEDIDA,  :NRORG,     'S',
                    SYSDATE,            :CDOPERINCLUSAO,    :NRORGINCLUSAO,         SYSDATE,    :CDOPERULTATU,
                    :NRORGULTATU
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function editUnidadeMedida($parametros) {
        $sql = "UPDATE FCM_UNIDADEMEDIDA
                SET NMUNIDADEMEDIDA         = :NMUNIDADEMEDIDA,
                    NMABREVUNIDADEMEDIDA    = :NMABREVUNIDADEMEDIDA,
                    DTULTATU                = SYSDATE,
                    CDOPERULTATU            = :CDOPERULTATU,
                    NRORGULTATU             = :NRORGULTATU
                WHERE NRUNIDADEMEDIDA = :NRUNIDADEMEDIDA";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getUnidadesMedida() {

        $sql = "SELECT NRUNIDADEMEDIDA, NMUNIDADEMEDIDA, NMABREVUNIDADEMEDIDA
                    FROM FCM_UNIDADEMEDIDA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function deleteUnidadesMedida($parametro) {

        $sql = "DELETE 
                FROM FCM_UNIDADEMEDIDA
                WHERE NRUNIDADEMEDIDA IN (".$parametro.")";

        $this->connection->executeStatement($sql);
    }
}

?>