<?php

namespace FM\Service;

use FM\Factory\CategoriaEquipFactory;
use FM\Factory\RelcategoriaequipmanutFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CategoriaEquipService {

    protected $CategoriaEquipFactory;
    protected $RelcategoriaequipmanutFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (CategoriaEquipFactory $CategoriaEquipFactory, EntityManager $entityManager, Environment $Environment, NewCode $newCode) {
        $this->CategoriaEquipFactory = $CategoriaEquipFactory;
        $this->connection = $entityManager->getConnection();
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function getCategorias() {
        return $this->CategoriaEquipFactory->getCategorias();
    }

    public function salvarCategoria($params) {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();
            if ($params["NRROW"] == null) {
                $NRCATEGORIAEQUIP = $this->newCode->getCodeByTableName("FCM_CATEGORIAEQUIP", 20, 1, 10, true);
    
                $parametroCategoria = array(
                    "NRCATEGORIAEQUIP"  => $NRCATEGORIAEQUIP,
                    "NMCATEGORIAEQUIP"  => $params["NMCATEGORIAEQUIP"],
                    "NRORG"             => $nrorg,
                    "CDOPERINCLUSAO"    => $operador,
                    "NRORGINCLUSAO"     => $nrorg
                );
    
                // $this->CategoriaEquipFactory->insertCategoria($parametroCategoria);
    
                foreach ($params["CATEGORIAS"] as $categoria) {
                    $NRRELCATEGORIAEQUIPMANUT = $this->newCode->getCodeByTableName("FCM_RELCATEGORIAEQUIPMANUT", 20, 1, 10, true);
    
                    $parametroManutencao = array(
                        "NRRELCATEGORIAEQUIPMANUT"  => $NRRELCATEGORIAEQUIPMANUT,
                        "NRCATEGORIAEQUIP"          => $NRCATEGORIAEQUIP,
                        "NRCATEGORIAMANUT"          => $categoria,
                        "NRORG"                     => $nrorg
                    );
    
                    // $this->CategoriaEquipFactory->insertRelCatManut($parametroManutencao);
                }
            } else {
                $NRCATEGORIAEQUIP = $params["NRROW"];

                $parametroCategoria = array(
                    "NRCATEGORIAEQUIP"  => $NRCATEGORIAEQUIP,
                    "NMCATEGORIAEQUIP"  => $params["NMCATEGORIAEQUIP"],
                    "CDOPERULTATU"      => $operador,
                    "NRORGULTATU"       => $nrorg
                );

                $this->CategoriaEquipFactory->updateCategoria($parametroCategoria);

                $this->CategoriaEquipFactory->deleteRelCatEquipManut($NRCATEGORIAEQUIP);
                
                foreach ($params["CATEGORIAS"] as $categoria) {
                    $NRRELCATEGORIAEQUIPMANUT = $this->newCode->getCodeByTableName("FCM_RELCATEGORIAEQUIPMANUT", 20, 1, 10, true);
    
                    $parametroManutencao = array(
                        "NRRELCATEGORIAEQUIPMANUT"  => $NRRELCATEGORIAEQUIPMANUT,
                        "NRCATEGORIAEQUIP"          => $NRCATEGORIAEQUIP,
                        "NRCATEGORIAMANUT"          => $categoria,
                        "NRORG"                     => $nrorg
                    );
    
                    $this->CategoriaEquipFactory->insertRelCatManut($parametroManutencao);
                }
            }

            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
        }
    }

    public function deleteCategorias($params) {
        $parametro = implode(',', $params["ROWS"]);
        $this->CategoriaEquipFactory->deleteRelCatEquipManut($parametro);
        $this->CategoriaEquipFactory->deleteCategorias($parametro);
    }

    public function getCategManutencao() {
        return $this->CategoriaEquipFactory->getCategManutencao();
    }

    public function getEquip() {
        return $this->CategoriaEquipFactory->getEquip();
    }
}

?>