<?php

namespace FM\Service;

use FM\Factory\EscopoManutFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class EscopoManutService {

    protected $EscopoManutFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, EscopoManutFactory $EscopoManutFactory, Environment $Environment, NewCode $newCode) {
        $this->EscopoManutFactory = $EscopoManutFactory;
        $this->connection         = $entityManager->getConnection();
        $this->Environment        = $Environment;
        $this->newCode            = $newCode;
    }

    public function saveEscopo($params) {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();
            
            foreach ($params["ROWS"] as $row) {
                if ($row["NRESCOPOMANUT"] == 0) {
                    $NRESCOPOMANUT = $this->newCode->getCodeByTableName("FCM_ESCOPOMANUT", $nrorg, 1, 10, true);
    
                    $parametrosEscopo = array(
                        "NRESCOPOMANUT"     => $NRESCOPOMANUT,
                        "NMESCOPOMANUT"     => $row['NMESCOPOMANUT'],
                        "NRORG"             => $nrorg,
                        "CDOPERINCLUSAO"    => $operador,
                        "NRORGINCLUSAO"     => $nrorg,
                        "CDOPERULTATU"      => $operador,
                        "NRORGULTATU"       => $nrorg          
                    );

                    $this->EscopoManutFactory->insertEscopo($parametrosEscopo);
                } else {
                    $parametrosEscopo = array(
                        "NRESCOPOMANUT"     => $row['NRESCOPOMANUT'],
                        "NMESCOPOMANUT"     => $row['NMESCOPOMANUT'],
                        "CDOPERULTATU"      => $operador,
                        "NRORGULTATU"       => $nrorg          
                    );

                    $this->EscopoManutFactory->editEscopo($parametrosEscopo);
                }
            }

            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
            throw $ex;
        }
    }

    public function getEscoposManutencao() {
        return $this->EscopoManutFactory->getEscoposManutencao();
    }

    public function deleteEscopos($params) {
        $parametro = implode(',', $params["NRS"]);
        $this->EscopoManutFactory->deleteEscopos($parametro);
    }
}

?>